#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

using namespace std;

int main(void) {
    int n, k;
    cin >> n >> k;
    vector<vector<long long>> up(n + 1, vector<long long> (n + 1, 0));
    vector<vector<long long>> down(n + 1, vector<long long> (n + 1, 0));
    //cout << "tag1";
    up[k][k] = 1;
    down[k][k] = 1;
    //cout << "flag";
    for(int i = k + 1; i <= n; ++i) {
        for(int j = 1; j <= i - k; ++j) {
            for(int w = 1 ; w < j && w <= i - k - j; ++w) {
                up[i][j] += down[i - j][w];
                up[i][j] %= 1000000007;
                //cout <<"tag1.1";
            }
            for(int w = j + 1; w <= i - j; ++w) {
                down[i][j] += up[i - j][w];
                down[i][j] %= 1000000007;
                //cout <<"tag1.2";
            }
            //cout << "tag2";
        }
    }
    //cout << "tag3";
    /*for(vector<int> a : up) {
        for(int b : a) cout << b << " ";
        cout << endl;
    }
    cout << endl << endl;
    for(vector<int> a : down) {
        for(int b : a) cout << b << " ";
        cout << endl;
    }

    */
    if(k == n) cout << 1;
    else {
        long long s = 0;
        for(int i = 1; i <= n; ++i) {
            s += up[n][i];
            s %= 1000000007;
            s += down[n][i];
            s %= 1000000007;
        }
        cout << s;
    }
}
