#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

using namespace std;

int main(void) {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> up(n + 1, vector<int> (n + 1, 0));
    vector<vector<int>> down(n + 1, vector<int> (n + 1, 0));
    //cout << "tag1";
    up[k][k] = 1;
    down[k][k] = 1;
    for(int i = k + 1; i <= n; ++i) {
        for(int j = 1; j <= i; ++j) {
            for(int w = 1 ; w < j; ++w) {
                up[i][j] += down[i - j][w];
            }
            for(int w = j + 1; w <= n; ++w) {
                down[i][j] += up[i - j][w];
            }
            //cout << "tag2";
        }
    }
    //cout << "tag3";
    if(k == n) cout << 1;
    else {
        long long s = 0;
        for(int i = 1; i <= n; ++i) {
            s += up[n][i] + down[n][i];
            if(s >= 1000000007) s %= 1000000007;
        }
        cout << s;
    }
}
