#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

using namespace std;

int m = 0;

void gen(int n, vector<int> ans, vector<int> g, int k) {
    bool exist = false;
    for(int i = 0; i < n; ++i) {
        bool fit = true;
        for(int j : ans) {
            if(i == j || g[j] == i || g[i] == j) fit = false;
        }
        if(fit) {
            exist = true;
            ans.push_back(i);
            gen(n, ans, g, k + 1);
            ans.pop_back();
        }
    }
    if(!exist) {
        if(k > m) m = k;
        return;
    }
}

int main(void) {
    int n;
    cin >> n;
    vector<int> g(n);
    for(int i = 0; i < n; ++i) {
            cin >> g[i];
            --g[i];
    }
    vector<int> ans;
    for(int i = 0; i < n; ++i) {
        ans.push_back(i);
        gen(n, ans, g, 1);
        ans.pop_back();
    }
    cout << m;
}
