#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

using namespace std;

vector<pair<int,int>> sans;
bool ans = false;

bool check(int k, vector<pair<int,int>> s, vector<vector<int>> a) {
    bool t = true;
    for(int i = 0; i < k; ++i) {
        int l = -1000000, r = 1000000;
        for(pair<int, int> j : s)  {
            l = max(l, a[j.first][i]);
            r = min(r, a[j.second][i]);
        }
        if(l >= r) {
            t = false;
            break;
        }
    }
    return t;
}

void gen(vector<pair<int,int>> &s, int n, int k, vector<vector<int>> &a){
    if(2*s.size() == n && check(k, s, a)) {
            ans = true;
            sans = s;
            for(pair<int, int> it : s) cout << "(" << it.first << ";" << it.second << ") ";
            cout << endl;
            return;
        }

    bool ia = true, ja = true;
    for(int i = 0; i < n; ++i) {
        for(pair<int,int> it : s) if(it.first == i || it.second == i) ia = false;
            if(ia) {for(int j = 0; j < n; ++j){
                for(pair<int,int> it : s) if(it.first == j || it.second == j) ja = false;
                if(ja && i != j) {
                    s.push_back({i,j});
                    gen(s, n, k, a);
                    s.pop_back();
                }
            }
        }
    }
}

int main(void) {
    int n, k;
    cin >> n >> k;

    /*if(k == 1){
        vector<pair<int,int>> p(n, {0, 0});
        for(int i = 0; i < n; ++i) p[i].second = i + 1;
        for(int i = 0; i < n; ++i) cin >> p[i].first;
        sort(p.begin(), p.end());
        if(p[n/2 - 1].first == p[n/2].first) {
            cout << "NO";
            return 0;
        }
        cout << "YES" << endl;
        for(int i = 0; i < n/2; ++i) {
            cout << p[i].second << " " << p[n - i - 1].second << endl;
        }
        return 0;
    }*/

    vector<vector<int>> a(n, vector<int>(k, 0));
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < k; ++j) cin >> a[i][j];
    vector<pair<int,int>> s;
    /*s.push_back({0,7});
    s.push_back({1,6});
    s.push_back({2,5});
    s.push_back({3,4});

    if(check(k, s, a)) cout << "sosi";
        */
    gen(s, n, k, a);
    if(!ans) cout << "NO";
    else {
        cout << "YES" << endl;
        for(pair<int, int> it : sans) cout << it.first << " " << it.second << endl;
    }
}
